=begin
**
** resources.rb
** 31/JUL/2008
** ETD-Software
**  - Daniel Martin Gomez <etd[-at-]nomejortu.com>
**
** Desc:
**   This file contains the ActiveResource models that are stored in the 
** server side
**
** License:
**   See dradis.rb or LICENSE.txt for copyright and licensing information.
**
=end

# Fix incompatibility with ruby 1.8.7
# See http://bicosyes.com/rails-2-1-con-ruby-1-8-7-broken/
begin
  String.class_eval{ remove_method :chars }
rescue NameError
  # other ruby version, OK
end

# FIXME: create a framework that would load everything in lib/ 
require 'lib/activeresource/lib/active_resource'

module Core
  module Model
    # ActiveResource models. This objects are stored in the dradis server
    module Resources
      RESTfulSite = $config.get_option(:restful_site)
      RESTfulSite += '/' unless  (RESTfulSite =~ /\/$/)
      RESTfulUser = $config.get_option(:restful_user)
      RESTfulPassword = $config.get_option(:restful_password)

      class Note < ActiveResource::Base
        self.site = "#{RESTfulSite}nodes/:node_id"
        self.user = RESTfulUser
        self.password = RESTfulPassword
      end
      class Node < ActiveResource::Base
        self.site = RESTfulSite
        self.user = RESTfulUser
        self.password = RESTfulPassword
      end    
      class Configuration < ActiveResource::Base
        self.site = RESTfulSite
        self.user = RESTfulUser
        self.password = RESTfulPassword
      end
      class Category < ActiveResource::Base
        self.site = RESTfulSite
        self.user = RESTfulUser
        self.password = RESTfulPassword
      end      
    end
  end
end
